Index: /other-projects/is-sheet-music-encore/trunk/image-identification-terminal/javaClassifierComparison.java
===================================================================
--- /other-projects/is-sheet-music-encore/trunk/image-identification-terminal/javaClassifierComparison.java	(revision 33588)
+++ /other-projects/is-sheet-music-encore/trunk/image-identification-terminal/javaClassifierComparison.java	(revision 33589)
@@ -72,32 +72,7 @@
     static double THRESHOLD_AREA_COUNT;
 
-//********************************************************************************************
-//CLASSES
-//********************************************************************************************
-	
-	//Sets globals based off properties file
-    public static void init(){
-		try{
-			Properties config = new Properties();
-			FileInputStream input = new FileInputStream("configClassifierComparison.properties");
-			config.load(input);
-			CLASSIFIER_HOUGHLINESP_MIN = 	Integer.parseInt(config.getProperty("CLASSIFIER_HOUGHLINESP_MIN"));
-			CLASSIFIER_HOUGHLINESP_MAX = 	Integer.parseInt(config.getProperty("CLASSIFIER_HOUGHLINESP_MAX"));
-			HOUGHLINEP_THRESHOLD = 			Integer.parseInt(config.getProperty("HOUGHLINEP_THRESHOLD")); 
-			STANDARD_DEVIATION_THRESHOLD = 	Integer.parseInt(config.getProperty("STANDARD_DEVIATION_THRESHOLD"));
-			MINLINECOUNT = 					Integer.parseInt(config.getProperty("MINLINECOUNT"));
-			MAXLINEGAP = 					Integer.parseInt(config.getProperty("MAXLINEGAP"));
-			THRESHOLD_C = 					Double.parseDouble(config.getProperty("THRESHOLD_C"));
-			SLOPEGRADIENT = 				Double.parseDouble(config.getProperty("SLOPEGRADIENT"));
-			CLUSTER_DISTANCE_MAX = 			Double.parseDouble(config.getProperty("CLUSTER_DISTANCE_MAX"));
-			CLUSTER_DISTANCE_MIN = 			Double.parseDouble(config.getProperty("CLUSTER_DISTANCE_MIN"));
-			THRESHOLD_AREA_SIZE =  			Double.parseDouble(config.getProperty("THRESHOLD_AREA_SIZE"));
-			THRESHOLD_AREA_COUNT = 			Double.parseDouble(config.getProperty("THRESHOLD_AREA_COUNT"));
-		}
-		catch(Exception e){
-			e.printStackTrace();
-		}
-	}
-    
+    //******************
+    //CLASSES
+    //******************
     static public class StartAndEndPoint {
         //PRIVATES
@@ -161,13 +136,40 @@
     }
 
+    //******************
+    //TRIGGERS
+    //******************
+    /**Sets globals based off properties file*/
+    public static void init(){
+        try{
+            Properties config = new Properties();
+            FileInputStream input = new FileInputStream("configClassifierComparison.properties");
+            config.load(input);
+            CLASSIFIER_HOUGHLINESP_MIN = 	Integer.parseInt(config.getProperty("CLASSIFIER_HOUGHLINESP_MIN"));
+            CLASSIFIER_HOUGHLINESP_MAX = 	Integer.parseInt(config.getProperty("CLASSIFIER_HOUGHLINESP_MAX"));
+            HOUGHLINEP_THRESHOLD = 			Integer.parseInt(config.getProperty("HOUGHLINEP_THRESHOLD"));
+            STANDARD_DEVIATION_THRESHOLD = 	Integer.parseInt(config.getProperty("STANDARD_DEVIATION_THRESHOLD"));
+            MINLINECOUNT = 					Integer.parseInt(config.getProperty("MINLINECOUNT"));
+            MAXLINEGAP = 					Integer.parseInt(config.getProperty("MAXLINEGAP"));
+            THRESHOLD_C = 					Double.parseDouble(config.getProperty("THRESHOLD_C"));
+            SLOPEGRADIENT = 				Double.parseDouble(config.getProperty("SLOPEGRADIENT"));
+            CLUSTER_DISTANCE_MAX = 			Double.parseDouble(config.getProperty("CLUSTER_DISTANCE_MAX"));
+            CLUSTER_DISTANCE_MIN = 			Double.parseDouble(config.getProperty("CLUSTER_DISTANCE_MIN"));
+            THRESHOLD_AREA_SIZE =  			Double.parseDouble(config.getProperty("THRESHOLD_AREA_SIZE"));
+            THRESHOLD_AREA_COUNT = 			Double.parseDouble(config.getProperty("THRESHOLD_AREA_COUNT"));
+        }
+        catch(Exception e){
+            e.printStackTrace();
+        }
+    }
+    /***/
     public static void main(String[] args) {
     	init();
         try {
         
-            if (args.length != 3) {
+            if (args.length < 3) {
                 System.out.println("Usage: imageClassifier <inputFilename> <classifierType> <outputFilename>");
+                System.out.println("+ (Optional)<BorderIgnoreAmount[0,5, 10, 20, 40]>");
             } else {
                 Pair algorithmResult = new Pair();
-
                 Boolean result = null;
                 String result_cluster = "";
@@ -176,33 +178,39 @@
                 String outputFilename = args[2];
                 Boolean enableLineClustering = null;
+
                 //Prep Writing output to disc
                 File log = new File(outputFilename);
                 FileWriter fileWriter = new FileWriter(log, true);
                 BufferedWriter bw = new BufferedWriter(fileWriter);
-                //Execute classifierType defined from arguement
-
                 File imgCheck = new File(imageFilename);
                 if(!imgCheck.exists()){System.err.println("Image not found: "+ imageFilename);}
 
-                //Split output by tab for processing in next java program
-                //imageFilename = 1, result = 3, classifierType = 4
-                
+//
+
+
+                //Arguement Preps
+                int borderIgnoreAmount;
+                if(args.length >= 4){borderIgnoreAmount =Integer.parseInt(args[3]);}
+                else {borderIgnoreAmount=-1;}
+
+                //imageFilename = 1, result = 3, classifierType = 4 ?????
                 switch (classifierType) {
+                    //Splits output by tab for processing in next java program
                     case "count":
                         enableLineClustering = false;
-                        algorithmResult = Algorithm_HoughLinesP_Single(imageFilename, enableLineClustering);
+                        algorithmResult = Algorithm_HoughLinesP_Single(imageFilename, enableLineClustering, borderIgnoreAmount);
                         bw.write("Filename:" + '\t' + imageFilename + '\t' + "Classified as:" + '\t' + algorithmResult.getBoolean() + '\t' + "Number of lines:" + '\t' + algorithmResult.getInteger() + '\t' + classifierType + '\n');
                         break;
                     case "cluster":
                         enableLineClustering = true;
-                        algorithmResult = Algorithm_HoughLinesP_Single(imageFilename, enableLineClustering);
+                        algorithmResult = Algorithm_HoughLinesP_Single(imageFilename, enableLineClustering, borderIgnoreAmount);
                         bw.write("Filename:" + '\t' + imageFilename + '\t' + "Classified as:" + '\t' + algorithmResult.getBoolean() + '\t' + "Number of lines:" + '\t' + algorithmResult.getInteger() + '\t' + classifierType + '\n');
                         break;
                     case "combo":
-                        algorithmResult = Algorithm_HoughLinesP_Combo(imageFilename);
+                        algorithmResult = Algorithm_HoughLinesP_Combo(imageFilename, borderIgnoreAmount);
                         bw.write("Filename:" + '\t' + imageFilename + '\t' + "Classified as:" + '\t' + algorithmResult.getBoolean() + '\t' + "Number of lines:" + '\t' + algorithmResult.getInteger() + '\t' + classifierType + '\n');
                         break;
                     case "morphology":
-                        algorithmResult = Algorithm_Morphology(imageFilename);
+                        algorithmResult = Algorithm_Morphology(imageFilename, borderIgnoreAmount);
                         bw.write("Filename:" + '\t' + imageFilename + '\t' + "Classified as:" + '\t' + algorithmResult.getBoolean() + '\t' + "Number of areas:" + '\t' + algorithmResult.getInteger() + '\t' + classifierType + '\n');
                         break;
@@ -210,6 +218,5 @@
                         System.out.println("unknown algorithm");
                         break;
-                }     
-                
+                }
                 bw.close();
             }
@@ -222,5 +229,14 @@
     //ALGORITHM FUNCTIONS
     //******************
-    private static Pair Algorithm_HoughLinesP_Single(String filename, Boolean enableLineClusterDetection){
+    private static Pair Algorithm_HoughLinesP_Single(String filename, Boolean enableLineClusterDetection, int borderIgnoreAmount){
+        //****************EXPLANATION**************************************************
+        //
+        //Load an image in greyscale
+        //Additional matrix to hold results of line detection
+        //Inversed Binarization of image
+        //Detect lines in image
+        //Go thru every line detected and check its gradient is less than SLOPEGRADIENT
+        //
+        //****************EXPLANATION**************************************************
         System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
         Boolean isSheetMusic = null;
@@ -235,17 +251,55 @@
             ArrayList<StartAndEndPoint> pointArrayList = new ArrayList<StartAndEndPoint>();
 
-            //****************EXPLANATION**************************************************
-            //
-            //Load an image in greyscale
-            //Additional matrix to hold results of line detection
-            //Inversed Binarization of image
-            //Detect lines in image
-            //Go thru every line detected and check its gradient is less than SLOPEGRADIENT
-            //
-            //****************EXPLANATION**************************************************
-
             Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
+            
+            Mat binarized = original.clone();
+            int blockSize = binarized.height()/3;
+            //BlockSize must be blockSize % 2 == 1 && blockSize > 1
+            while (!(blockSize % 2 == 1 && blockSize > 1)) {
+            	blockSize++;
+            }
+            
+            
+		    System.out.println("Width: " + binarized.width() + " Height: " + binarized.height());
+		    //************************
+		    //Argument Setup
+		    //************************
+		    double divisor;
+		    switch (borderIgnoreAmount){
+		        case 5:
+		            divisor = 40;
+		            break;
+		        case 10:
+		            divisor = 20;
+		            break;
+		        case 20:
+		            divisor = 10;
+		            break;
+		        case 40:
+		            divisor = 5;
+		            break;
+		        case -1:
+		            divisor = -1;
+		            break;
+		        default: divisor = -1;
+		    }
+		    if(divisor != -1 ) {
+		        Mat mid = new Mat();
+		        Imgproc.adaptiveThreshold(original, mid,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, blockSize, THRESHOLD_C);
+		        //Remove borders from Mat
+		        //Get width and
+		        double maxX = mid.size().width;
+		        double maxY = mid.size().height;
+		        Point cp1 = new Point(maxX / divisor, maxY / divisor);
+		        Point cp2 = new Point(maxX - cp1.x, maxY - cp1.y);
+		        Rect rectCrop = new Rect(cp1, cp2);
+		        binarized = mid.submat(rectCrop);
+		    }
+		    else{Imgproc.adaptiveThreshold(original, binarized,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, blockSize, THRESHOLD_C);}
+		    System.out.println("Width: " + binarized.width() + " Height: " + binarized.height()); 
+		    edgesDetected = binarized.clone();
+            
+            
             Mat linesP = new Mat(); //will hold the results of the detection
-            Imgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV,15, THRESHOLD_C);
             double minLineLength = edgesDetected.size().width/8;
             Imgproc.HoughLinesP(edgesDetected, linesP, 1, Math.PI / 720, HOUGHLINEP_THRESHOLD, minLineLength, MAXLINEGAP);
@@ -274,5 +328,15 @@
         return returnVariables;
     }
-    private static Pair Algorithm_HoughLinesP_Combo(String filename){
+    private static Pair Algorithm_HoughLinesP_Combo(String filename, int borderIgnoreAmount){
+        //****************EXPLANATION**************************************************
+        //
+        //Load an image in greyscale
+        //Additional matrix to hold results of line detection
+        //Inversed Binarization of image
+        //Detect lines in image
+        //Go thru every line detected and check its gradient is less than SLOPEGRADIENT
+        //
+        //****************EXPLANATION**************************************************
+        
         System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
         Boolean isSheetMusic = null;
@@ -281,4 +345,5 @@
             //Variables
             int horizontalLineCount =0;
+            
             Mat edgesDetected = new Mat();
             Mat edgesDetectedRGB = new Mat();
@@ -286,18 +351,51 @@
             Mat edgesDetectedRGBProb;
             ArrayList<StartAndEndPoint> pointArrayList = new ArrayList<StartAndEndPoint>();
-
-            //****************EXPLANATION**************************************************
-            //
-            //Load an image in greyscale
-            //Additional matrix to hold results of line detection
-            //Inversed Binarization of image
-            //Detect lines in image
-            //Go thru every line detected and check its gradient is less than SLOPEGRADIENT
-            //
-            //****************EXPLANATION**************************************************
-
             Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
+            
+		    Mat binarized = original.clone();
+		    int blockSize = binarized.height()/3;
+		    while (!(blockSize % 2 == 1 && blockSize > 1)) {
+            	blockSize++;
+            }
+		    System.out.println("Width: " + binarized.width() + " Height: " + binarized.height());
+		    //************************
+		    //Argument Setup
+		    //************************
+		    double divisor;
+		    switch (borderIgnoreAmount){
+		        case 5:
+		            divisor = 40;
+		            break;
+		        case 10:
+		            divisor = 20;
+		            break;
+		        case 20:
+		            divisor = 10;
+		            break;
+		        case 40:
+		            divisor = 5;
+		            break;
+		        case -1:
+		            divisor = -1;
+		            break;
+		        default: divisor = -1;
+		    }
+		    if(divisor != -1 ) {
+		        Mat mid = new Mat();
+		        Imgproc.adaptiveThreshold(original, mid,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, blockSize, THRESHOLD_C);
+		        //Remove borders from Mat
+		        //Get width and
+		        double maxX = mid.size().width;
+		        double maxY = mid.size().height;
+		        Point cp1 = new Point(maxX / divisor, maxY / divisor);
+		        Point cp2 = new Point(maxX - cp1.x, maxY - cp1.y);
+		        Rect rectCrop = new Rect(cp1, cp2);
+		        binarized = mid.submat(rectCrop);
+		    }
+		    else{Imgproc.adaptiveThreshold(original, binarized,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, blockSize, THRESHOLD_C);}
+		    System.out.println("Width: " + binarized.width() + " Height: " + binarized.height()); 
+		    edgesDetected = binarized.clone();
+
             Mat linesP = new Mat(); //will hold the results of the detection
-            Imgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV,15, THRESHOLD_C);
             double minLineLength = edgesDetected.size().width/8;
             Imgproc.HoughLinesP(edgesDetected, linesP, 1, Math.PI / 720, HOUGHLINEP_THRESHOLD, minLineLength, MAXLINEGAP);
@@ -320,4 +418,5 @@
             }
             else if (isSheetMusic == false){
+            	System.out.println("TEST");
                 returnVariables = Classifier_ClusterDetection(pointArrayList);
             }
@@ -328,272 +427,56 @@
         return returnVariables;
     }
-    private static Pair Algorithm_MorphologyOLD2(String filename){
-
+    private static Pair Algorithm_Morphology(String filename, int borderIgnoreAmount){
         System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
-        Boolean isSheetMusic = null;
         Pair returnVariables = new Pair();
         int areaCounter = 0;
-        try{
-            Mat edgesDetectedRGB = new Mat();
-            Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
-
-            System.out.println("Width: " + original.width() + " Height: " + original.height());
-
-            ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
-            Mat hierarchy = new Mat();
-
-            //Thresholds
-            Imgproc.adaptiveThreshold(original, original,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
-            Mat processed = original.clone();
-            //Morphological Processing
-            Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,1));
-            Imgproc.erode(processed,processed,kernelErode);
-
-            Mat kernelDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(20,3));
-            Imgproc.dilate(processed,processed,kernelDilate);
-
-            Mat kernelOpening = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(4,4));
-            Imgproc.morphologyEx(processed, processed, Imgproc.MORPH_CLOSE, kernelOpening);
-
-            Mat kernelErode02 = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(8,8));
-            Imgproc.erode(processed,processed,kernelErode02);
-
-            //Detect contours
-            Imgproc.findContours(processed, contours, hierarchy, Imgproc.RETR_TREE, Imgproc.CHAIN_APPROX_SIMPLE);
-
-            //Record areas
-            for (int i = 0; i < contours.size(); i++) {
-                double area = Imgproc.contourArea(contours.get(i));
-                System.out.println("AREA: " + area);
-                //Check if area detected meets threshold
-                if(area > THRESHOLD_AREA_SIZE) {
-                    areaCounter++;
-
-                }
-            }
-            System.out.println("areacount = " + areaCounter);
-
-            //Calculates if sheet music or not
-            if(areaCounter >= THRESHOLD_AREA_COUNT){
-                isSheetMusic = true;
-                returnVariables.setBoolean(isSheetMusic);
-                returnVariables.setInteger(areaCounter);
-            }
-        }
-        catch(Exception e){
-            System.err.println(e);
-        }
-        return returnVariables;
-    }
-    private static Pair Algorithm_MorphologyOLD(String filename){
-
-        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
-        Boolean isSheetMusic = null;
-        Pair returnVariables = new Pair();
-        int FILLED = -1;
-        try{
-            Mat original1 = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
-            System.out.println("Width: " + original1.width() + " Height: " + original1.height());
-            Mat original = original1.clone();
-            Imgproc.adaptiveThreshold(original1, original,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
-            Mat test = original.clone();
-            //************************************
-            //Large Object Removal
-            //************************************
-            Mat srcLOR = original.clone();
-            Mat maskLOR = new Mat();
-            Mat dstLOR = new Mat();
-
-            //denoize
-            Mat denoize = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
-            Imgproc.morphologyEx(srcLOR,maskLOR, Imgproc.MORPH_OPEN, denoize);
-
-            //close up gaps
-            Mat gapCloser = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
-            Imgproc.morphologyEx(maskLOR,maskLOR,Imgproc.MORPH_CLOSE, gapCloser);
-
-            //Isolate large items
-            Mat isolateLarge = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(8, 8));
-            Imgproc.morphologyEx(maskLOR,maskLOR,Imgproc.MORPH_OPEN, isolateLarge);
-
-            //Remove large items from image
-            Core.bitwise_not(maskLOR,maskLOR);
-            srcLOR.copyTo(dstLOR, maskLOR);
-
-            //****************************************
-            //Small object removal (SOR)
-            //****************************************
-
-            Mat srcSOR = dstLOR.clone();
-            Mat maskSOR = new Mat();
-            Mat dstSOR = new Mat();
-
-            Mat startSOR =Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(7,7));
-            Imgproc.morphologyEx(srcSOR,maskSOR, Imgproc.MORPH_OPEN, startSOR);
-
-            Mat highlightSmall = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(7,7));
-            Imgproc.dilate(maskSOR, maskSOR, highlightSmall);
-
-
-/*              Mat isolateSmall =Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,10));
-                Imgproc.morphologyEx(maskSOR,maskSOR,Imgproc.MORPH_CLOSE, isolateSmall);
-                imageViewer("13 isolate small - mask", maskSOR);
-*/
-
-            //Remove small items from image
-            Core.bitwise_not(maskSOR, maskSOR);
-            srcSOR.copyTo(dstSOR, maskSOR);
-
-
-            //****************************************
-            //start staff line detection
-            //****************************************
-
-            Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(15,2)); //10,2
-            Imgproc.erode(dstSOR,test,kernelErode);
-
-
-            Mat kernelDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //20,3
-            Imgproc.dilate(test,test,kernelDilate);
-
-
-            Mat kernelClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //4,4
-            Imgproc.morphologyEx(test, test, Imgproc.MORPH_CLOSE, kernelClose);
-
-
-
-            Mat kernelErode02 = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //10,1
-            Imgproc.erode(test,test,kernelErode02);
-
-
-            //********************************************************************************
-            //DETECT OUTLINE AND FIND AREA OF THESE LINES.
-            //********************************************************************************
-            ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
-            ArrayList<MatOfPoint> largeContours = new ArrayList<MatOfPoint>();
-            ArrayList<MatOfPoint> postContours = new ArrayList<MatOfPoint>();
-            Mat hierarchy = new Mat();
-
-            //PARAMETERS: input image, output array of arrays, output array, contour retrieval mode, contour approximation method.
-            //(contours)  output array of arrays: Detected contours. Each contour is stored as a vector of points
-            //(hierarchy) output array:           Optional output vector, containing information about the image topology.
-            //https://docs.opencv.org/3.3.1/d3/dc0/group__imgproc__shape.html#ga17ed9f5d79ae97bd4c7cf18403e1689a
-
-            Imgproc.findContours(test, contours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);
-
-            System.out.println(contours.size());
-            //Draw contours and record areas
-            Mat allContoursFound = Mat.zeros(test.size(), CvType.CV_8UC3);
-            Mat largeContoursFound = allContoursFound.clone() ;
-            Mat postContoursFound = allContoursFound.clone();
-            int areaCounter = 0;
-
-            //Have created a preprocess to remove large objects.
-            //Need to now finalized Classifier, re try area detection.
-            //Paths to take - rectangle boxes around detected contours over threshold (area or perimeter)
-            //Just use area and periemter to determine if sheet music
-            //Discuss with david before weekend perhaps?
-
-            Imgproc.drawContours(allContoursFound, contours, -1, new Scalar(0, 255, 0), 1); //USES LINE_8
-            for (int i = 0; i < contours.size(); i++) {
-                double area = Imgproc.contourArea(contours.get(i));
-                if(area > 100) {
-                    //System.out.println("AREA: " + area);
-                    Imgproc.drawContours(largeContoursFound, contours, i, new Scalar(255, 0, 0), FILLED);
-                    //create list of large coutours found
-                    largeContours.add(contours.get(i));
-                }
-            }
-
-            //*****************************************************************
-            //Circles and centres on processed images
-            //*****************************************************************
-
-            //Init arrays
-            Mat circleOutput = allContoursFound.clone();
-            MatOfPoint2f[] contoursPoly  = new MatOfPoint2f[largeContours.size()];
-            Point[] centers = new Point[largeContours.size()];
-            float[][] radius = new float[largeContours.size()][1];
-
-            //Fill arrays
-            for (int i = 0; i < largeContours.size(); i++) {
-                contoursPoly[i] = new MatOfPoint2f();
-                Imgproc.approxPolyDP(new MatOfPoint2f(largeContours.get(i).toArray()), contoursPoly[i], 1, true);
-                centers[i] = new Point();
-                Imgproc.minEnclosingCircle(contoursPoly[i], centers[i], radius[i]);
-
-            }
-            //Draw circle for each large contour
-            for (int i = 0; i < largeContours.size(); i++) {
-                Imgproc.circle(circleOutput, centers[i], (int) radius[i][0],new Scalar(255, 0, 0), 1);
-            }
-
-
-            //********************************************************************************
-            //Centroids - Everything must be to scale
-            //********************************************************************************
-
-            ArrayList<Moments> mu = new ArrayList<Moments>(largeContours.size());
-            Mat centreOutput = Mat.zeros(largeContoursFound.size(), CvType.CV_8UC3);
-            for (int i = 0; i < largeContours.size(); i++) {
-                mu.add(i, Imgproc.moments(largeContours.get(i), false));
-                Moments p = mu.get(i);
-                int x = (int) (p.get_m10() / p.get_m00());
-                int y = (int) (p.get_m01() / p.get_m00());
-                Imgproc.circle(centreOutput, new Point(x, y), 4, new Scalar(255, 255, 255), 30);
-            }
-
-            //***********************************************
-            //PostProcessing - Morphology Classifier
-            //  Use dilation to "Connect the dots"
-            //  Testing showed the centroids were clustered together
-            //  Then use area or perimeter as a classifier filter
-            //***********************************************
-
-            Mat postDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(150,15));
-            Imgproc.dilate(centreOutput,centreOutput,postDilate);
-
-            Mat postClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //4,4
-            Imgproc.morphologyEx(centreOutput, centreOutput, Imgproc.MORPH_CLOSE, postClose);
-
-            Mat postDenoize = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(100,100));
-            Imgproc.morphologyEx(centreOutput,centreOutput, Imgproc.MORPH_OPEN, postDenoize);
-
-            //Find area
-            Mat centreOutputGrey = new Mat();
-            Imgproc.cvtColor(centreOutput, centreOutputGrey, Imgproc.COLOR_RGB2GRAY);
-            Imgproc.findContours(centreOutputGrey, postContours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);
-
-            for (int i = 0; i < postContours.size(); i++) {
-                double area = Imgproc.contourArea(postContours.get(i));
-                if(area > THRESHOLD_AREA_SIZE) {
-                    //System.err.println("POST AREA: " + area);
-                    Imgproc.drawContours(postContoursFound, postContours, i, new Scalar(0, 255, 0), FILLED);
-                    areaCounter++;
-                }
-            }
-            //Classifier Calculation
-            if(areaCounter >= THRESHOLD_AREA_COUNT){
-                returnVariables.setBoolean(true);
-                returnVariables.setInteger(areaCounter);
-            }
-        }
-        catch(Exception e){
-            System.err.println(e);
-        }
-        return returnVariables;
-    }
-    private static Pair Algorithm_Morphology(String filename){
-        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
-        Pair returnVariables = new Pair();
-        int areaCounter=0;
         Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
-        Mat binarizedOriginal = original.clone();
-        Imgproc.adaptiveThreshold(original, binarizedOriginal,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
+        Mat binarized = original.clone();
+     	int blockSize = binarized.height()/3;   
+     	while (!(blockSize % 2 == 1 && blockSize > 1)) {
+          	blockSize++;
+        }
+        System.out.println("Width: " + binarized.width() + " Height: " + binarized.height());
+        //************************
+        //Argument Setup
+        //************************
+        double divisor;
+        switch (borderIgnoreAmount){
+            case 5:
+                divisor = 40;
+                break;
+            case 10:
+                divisor = 20;
+                break;
+            case 20:
+                divisor = 10;
+                break;
+            case 40:
+                divisor = 5;
+                break;
+            case -1:
+                divisor = -1;
+                break;
+            default: divisor = -1;
+        }
+        if(divisor != -1 ) {
+            Mat mid = new Mat();
+            Imgproc.adaptiveThreshold(original, mid,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, blockSize, THRESHOLD_C);
+            //Remove borders from Mat
+            //Get width and
+            double maxX = mid.size().width;
+            double maxY = mid.size().height;
+            Point cp1 = new Point(maxX / divisor, maxY / divisor);
+            Point cp2 = new Point(maxX - cp1.x, maxY - cp1.y);
+            Rect rectCrop = new Rect(cp1, cp2);
+            binarized = mid.submat(rectCrop);
+        }
+        else{Imgproc.adaptiveThreshold(original, binarized,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, blockSize, THRESHOLD_C);}
+        System.out.println("Width: " + binarized.width() + " Height: " + binarized.height());
         try{
             //************************************
             //1. Large Object Remover
             //************************************
-            Mat srcLOR = binarizedOriginal.clone();
+            Mat srcLOR = binarized.clone();
             Mat maskLOR = new Mat();
             Mat dstLOR = new Mat();
@@ -614,5 +497,5 @@
             srcLOR.copyTo(dstLOR, maskLOR);
 
-            Mat base = binarizedOriginal.clone();
+            Mat base = binarized.clone();
             //***********************************
             //3. Isolate straight lines
